/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: cviolat.cpp,v 1.4 1997/06/24 17:28:42 reichel Exp $ *
 ***********************************************************************/


#include <fstream.h>
#include "cviolation.h"



//-------------------------------------------------------------------------
ConstrViolation::ConstrViolation(void)
{
  init();
}
//-------------------------------------------------------------------------
ConstrViolation::ConstrViolation(ConstrViolation  & const source)
{
  init();
  copy(source);
}
//-------------------------------------------------------------------------
virtual ConstrViolation::~ConstrViolation(void)	// ConstrViolation destructor #1
{};
//-------------------------------------------------------------------------
void ConstrViolation::init(void)
{
  type=0;
  strcpy(name,"");
}
//-------------------------------------------------------------------------
void ConstrViolation::clear(void)
{}
//-------------------------------------------------------------------------
void ConstrViolation::copy(ConstrViolation & const source)
{ 
  type = source.type;
  strcpy(name,source.name);
  place=source.place;
}

//-------------------------------------------------------------------------
ConstrViolation &ConstrViolation::operator = (ConstrViolation & const source)
{
  clear();
  copy(source);
  return(*this);
};

//===================================================================
bool ConstrViolation::write(ofstream &outfile,bool up)
{
  char		meth[LENGTH_OF_NAMES];
  int		len;
  int k;

  if(!(outfile<<endl<<"  "<<type<<" "<<name<<" "<<place.agg<<" "<<place.pla<<" " <<place.num<<endl<<"       "))
  {
    strcpy(meth,"ConstrViolation::write");
    len=strlen(meth);
    domflip_error.set(domflip_error_t::file_write_error_in,len,meth);
    return(false);
  }
  else
    return(true);
}

//===================================================================
bool ConstrViolation::read (ifstream &infile,bool up)
{
  char		meth[LENGTH_OF_NAMES];
  int		len;

  if(up)
    if(!ConstrViolation::read(infile))
    {
      strcpy(meth,"ConstrViolation::read");
      len=strlen(meth);
      domflip_error.set(domflip_error_t::file_read_error_in,len,meth);
      clear();
      return(false);
    }
  if(!(infile>>(int)type))
  {
    strcpy(meth,"ConstrViolation::read (type)");
    len=strlen(meth);
    domflip_error.set(domflip_error_t::file_read_error_in,len,meth);
    clear();
    return(false);
  }
  else
  {
    if(!(infile>>name))
    {
      strcpy(meth,"ConstrViolation::read (name)");
      len=strlen(meth);
      domflip_error.set(domflip_error_t::file_read_error_in,len,meth);
      clear();
      return(false);
    }
    else
    {
      if(!(infile>>place.agg))
      {
        strcpy(meth,"ConstrViolation::read (place.agg)");
        len=strlen(meth);
        domflip_error.set(domflip_error_t::file_read_error_in,len,meth);
        clear();
        return(false);
      }
      else
      {
        if(!(infile>>place.pla))
  	{
          strcpy(meth,"ConstrViolation::read (place.pla)");
          len=strlen(meth);
      	  domflip_error.set(domflip_error_t::file_read_error_in,len,meth);
    	  clear();
    	  return(false);
  	}
  	else
	{
  	  if(!(infile>>place.num))
  	  {
    	    strcpy(meth,"ConstrViolation::read (place.num)");
    	    len=strlen(meth);
    	    domflip_error.set(domflip_error_t::file_read_error_in,len,meth);
    	    clear();
    	    return(false);
  	  }
	}
      }
    }
  }
  return(true);
};

//-------------------------------------------------------------------------
int ConstrViolation::get_key(void)	// !!!!
{
  return(type);
}
//-------------------------------------------------------------------------
char* ConstrViolation::get_name(void)
{
  return(name);
}
//-------------------------------------------------------------------------
ind ConstrViolation::get_place()
{
  return(place);
}
