/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: cviolat.h,v 1.4 1997/06/24 17:28:43 reichel Exp $ *
 ***********************************************************************/


#ifndef _CVIOLATION
#define _CVIOLATION

// !!!!!!!!!!!!!!!!!!
// **** DOMAIN 1 ****
#include "domain1.h"
// ******************


// **** DOMAIN 2 ****
//#include "domain2.h"
// ******************


enum constr_type {item=0, agg=1, dom=2};

struct ind
{
  int  	agg;
  int	pla;
  int	num;
};

//===========================================================================
class ConstrViolation
//===========================================================================
{
private:
  constr_type	type;
  char		name[LENGTH_OF_NAMES];
  ind		place;


public:
  ConstrViolation  (void);
  ConstrViolation  (ConstrViolation & const);		
  ~ConstrViolation (void);

  void		init(void);
  void 		clear(void);
  void  	copy(ConstrViolation & const);

  ConstrViolation &operator =(ConstrViolation & const);

  virtual bool write(ofstream &,bool =true);
  virtual bool read(ifstream &,bool =true);

  int		get_key(void);	// !!!!


  int		get_type(void);
  char 		*get_name(void);
  ind	  	get_place(void);

};

#endif
