/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: cviollst.cpp,v 1.4 1997/06/24 17:28:45 reichel Exp $ *
 ***********************************************************************/


#include "cviollst.h"


/*-------------------------------------------------------------------*/
/* ListOfCviol                                            	     */
/*-------------------------------------------------------------------*/
// ******************************************************************

ListOfCviol::ListOfCviol(void) : GenList()
{}
ListOfCviol::ListOfCviol(ListOfCviol & const source) : GenList(source)
{}
ListOfCviol::ListOfCviol(SledForCviol & const source) : GenList(source)
{}
ListOfCviol::~ListOfCviol(void)
{
  clear();
}
//===================================================================
void ListOfCviol::del(void *ptr)
{
  if(ptr!=NULL)
  delete((ConstrViolation *)ptr);
}
//===================================================================
void *ListOfCviol::key(void *info)
{
   return(((ConstrViolation *)info)->get_name()); 
}
//=================================================================== 
bool ListOfCviol::look(void *wanted,void *info)
{
  return((bool)(strcmp((char *)wanted,((ConstrViolation *)info)->get_name())==0));
}
/*
//===================================================================
bool ListOfCviol::cmp(void *ptr1,void *ptr2)
{
  return((bool)(strcmp((char *)ptr1,(char *)ptr2)==0));
}
*/
//=================================================================== 
void ListOfCviol::cpy(void *&item,void *info)
{  
  item=(ConstrViolation *)new(ConstrViolation);
  (*(ConstrViolation *)item)=(*(ConstrViolation *)info);
}

//===================================================================
bool ListOfCviol::rd(ifstream &infile,void *&item)
{
  ConstrViolation temp;

  //cout<<"ListOfCviol::rd"<<endl;
  //(*(ConstrViolation *)item)=temp;
  //cout<<"ListOfCviol::rd"<<endl;

  item=(ConstrViolation *)new(ConstrViolation);
  if( ((ConstrViolation *) item)->read(infile,false))
  {
    return(true);
  }
  else
  {
    delete ((ConstrViolation *)item);
    // domflip_error.set(domflip_error_t::file_read_error);
    return(false);
  }
}    
//===================================================================
bool ListOfCviol::wr(ofstream &outfile,void *item)
{
  return(((ConstrViolation *)item)->write(outfile));
} 

//===================================================================

ListOfCviol &ListOfCviol::operator =(ListOfCviol & const source)
{
  // clear();
  copy(source);
  // GenList::operator =(source);
  return(*this);
}


//===================================================================
ListOfCviol &ListOfCviol::operator =(SledForCviol & const source)
{
  // clear();
  copy(source);
  // GenList::operator=(source);
  return(*this);
}

//=================================================================== 
/* 
bool ListOfCviol::operator ==(ListOfCviol & const par)
{
  return(GenList::operator ==(par));
}
//=================================================================== 
bool ListOfCviol::week_equal(ListOfCviol & const par)
{
  return(GenList::week_equal(par));
}
*/ 
//=================================================================== 
bool ListOfCviol::add(ConstrViolation *term,InfoCopy c)
{
  return(GenList::add((void *)term,c));
}
//=================================================================== 
/*
bool ListOfCviol::add_quick(char *term,InfoCopy c)
{
  return(GenList::add_quick(term,c));
}
//===================================================================  
bool ListOfCviol::kick_out(char *term)
{
  return(GenList::kick_out(term));
}
*/
//=================================================================== 
ConstrViolation *ListOfCviol::lookup(char *s)
{
  return((ConstrViolation *)get_info(GenList::lookup((void *)s)));
}
//===================================================================

//===================================================================
int SledForCviol::get_entr_key(int i)
{
return(((ConstrViolation *)operator[](i))->get_key());
}
