/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: domaglst.h,v 1.4 1997/06/24 17:28:52 reichel Exp $ *
 ***********************************************************************/



/**********************************************************************/
/* ListOfAgg                                                          */
/*--------------------------------------------------------------------*/


#ifndef _DOMAGGLST
#define _DOMAGGLST

#include "domagg.h"

class SledForAgg;
//===========================================================================
class ListOfAgg : public GenList
//===========================================================================
{
  friend class SledForAgg;
protected:
  virtual void 	del(void *);
  virtual void 	*key(void *);
  virtual bool 	look(void *,void *);
  // virtual bool cmp(void *,void *);			// !!
  virtual void 	cpy(void *&,void *);
  virtual bool 	rd(ifstream &,void *&);
  virtual bool 	wr(ofstream &,void *);
  bool 		wr_agg(ofstream &,void *);
  bool 		wr_constr(ofstream &,void *);
  bool 		wr_data(ofstream &,void *);
  void 		clr_cons(void *);
  void 		clr_dat(void *);

public:
  ListOfAgg(void);
  ListOfAgg(ListOfAgg & const);		
  ListOfAgg(SledForAgg & const);	
  ~ListOfAgg(void);

  bool add(Aggregate *,InfoCopy=copy_when_insert);
  bool kick_out(char *s);				// !!
  Aggregate *lookup(char *);
  //bool check_agg_list(char *);			// !!
  bool write_agg(ofstream &);
  bool write_constr(ofstream &);
  bool write_data(ofstream &);
  void clear_cons(void);
  void clear_dat(void);

  ListOfAgg &operator =(ListOfAgg & const);
  ListOfAgg &operator =(SledForAgg & const);
//  ListOfAgg operator  ==(ListOfAgg & const);		// !!

}; 
 
//===========================================================================
class SledForAgg : public GenSled
//===========================================================================
{
  friend class ListOfAgg;
public:
  SledForAgg(void) : GenSled() {}
  SledForAgg(ListOfAgg & const l) : GenSled((GenList &)l) {}
  SledForAgg(ListOfAgg * const l) : GenSled((GenList *)l) {}

  char *lookup(char *l) { return((char *)GenSled::lookup((char *)l)); }
  //bool insert(Aggregate *k,InfoCopy c=copy_when_insert) { return(GenSled::insert(k,c)); }			// !!
  bool kick_out(void) { return(GenSled::kick_out()); }
  bool add(Aggregate *k,InfoCopy c=copy_when_insert) { return(GenSled::add(k,c)); }


  int		get_nr_of_entries(void);
  int		get_entry(int);
  float		get_evaluation(void);
  ListOfAgg *	get_list_ptr(void);
  float		evaluate_plan(void);
  void 		copy_sched(SledForAgg *);


  bool  	call_repair(int,int,ind);
  void 		show_sched(void);

  bool  	change(ind,ind);
  bool 		move(ind,ind);
}; 
#endif
