/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: domain1.cpp,v 1.4 1997/06/24 17:28:53 reichel Exp $ *
 ***********************************************************************/


#include "domain1.h"

/*-------------------------------------------------------------------*/
/* ListOfEntr                                            	     */
/*-------------------------------------------------------------------*/
// ******************************************************************

ListOfEntr::ListOfEntr(void) : GenList()
{}
ListOfEntr::ListOfEntr(ListOfEntr & const source) : GenList(source)
{}
ListOfEntr::ListOfEntr(SledForEntr & const source) : GenList(source)
{}
ListOfEntr::~ListOfEntr(void)
{
  clear();
}
//===================================================================
void ListOfEntr::del(void *ptr)
{
  // cout<<"ListOfEntr::del!!!!!!!"<<endl;
  if(ptr!=NULL)
  delete((Order *)ptr);
}
//===================================================================
void *ListOfEntr::key(void *info)
{
   return(((Order *)info)->get_onumber()); 
}
//=================================================================== 
bool ListOfEntr::look(void *wanted,void *info)
{
  long		onum1,onum2;

  onum1 = ((Order *)info)->get_onumber();
  // cout<<"NUM: "<<onum1<<endl;

  onum2 = *((long *)wanted);
  // cout<<"CPY: "<<onum2<<endl;

  return((bool) onum1 == onum2);
}
/*
//===================================================================
bool ListOfEntr::cmp(void *ptr1,void *ptr2)
{
  return((bool)(strcmp((char *)ptr1,(char *)ptr2)==0));
}
*/
//=================================================================== 
void ListOfEntr::cpy(void *&item,void *info)
{  
  item=(Order *)new(Order);
  //((Order *)item)->set_onumber(((Order *)info)->get_onumber());
  //((Order *)item)->set_plantmark(((Order *)info)->get_plantmark());
  //((Order *)item)->set_weight(((Order *)info)->get_weight());

  (*(Order *)item)=(*(Order *)info);

  //cout<<"ListOfEntr::cpy Onumber:   "<<((Order *)item)->get_onumber()<<endl;
  //cout<<"ListOfEntr::cpy plantmark: "<<((Order *)item)->get_plantmark()<<endl;
  //cout<<"ListOfEntr::cpy weight:    "<<((Order *)item)->get_weight()<<endl;
}

//===================================================================
bool ListOfEntr::rd(ifstream &infile,void *&item)
{
  Order 	temp;
  char		meth[LENGTH_OF_NAMES];
  int		len;


  item=(Order *)new(Order);

  if( ((Order *) item)->read(infile,false))
  {
    return(true);
  }
  else
  {
    delete ((Order *)item);
    return(false);
  }
}    
//===================================================================
bool ListOfEntr::wr(ofstream &outfile,void *item)
{
  return(((Order *)item)->write(outfile));
} 

//===================================================================

ListOfEntr &ListOfEntr::operator =(ListOfEntr & const source)
{
  clear();
  copy(source);
  return(*this);
}


//===================================================================
ListOfEntr &ListOfEntr::operator =(SledForEntr & const source)
{
  clear();
  copy(source);
  // GenList::operator=(source);
  return(*this);
}

//=================================================================== 
/* 
bool ListOfEntr::operator ==(ListOfEntr & const par)
{
  return(GenList::operator ==(par));
}
//=================================================================== 
bool ListOfEntr::week_equal(ListOfEntr & const par)
{
  return(GenList::week_equal(par));
}
*/ 
//=================================================================== 
bool ListOfEntr::add(Order *term,InfoCopy c)
{
  return(GenList::add((void *)term,c));
}
//=================================================================== 
/*
bool ListOfEntr::add_quick(char *term,InfoCopy c)
{
  return(GenList::add_quick(term,c));
}
//===================================================================  
bool ListOfEntr::kick_out(char *term)
{
  return(GenList::kick_out(term));
}
*/
//=================================================================== 
Order *ListOfEntr::lookup(char *s)
{
  return((Order *)get_info(GenList::lookup((void *)s)));
}
//===================================================================
ListOfEntr * SledForEntr::get_list_ptr(void)
{
  return ((ListOfEntr *)list_ptr);
}
//===================================================================
void SledForEntr::copy_entr(SledForEntr* source)
{
  list_ptr=new(ListOfEntr);
  *list_ptr=*((ListOfEntr *)(source->list_ptr));
  first();
  operator[](source->index);
}
//===================================================================
int SledForEntr::get_entr_key(int i)
{
return(((Order *)operator[](i))->get_key());
}
