/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: domain1.h,v 1.4 1997/06/24 17:28:54 reichel Exp $ *
 ***********************************************************************/


// domain1.h

#ifndef _DOM1
#define _DOM1


#include "order.h"

class SledForEntr;
//===========================================================================
class ListOfEntr : public GenList
//===========================================================================
{
protected:
  virtual void del(void *);
  virtual void *key(void *);
  virtual bool look(void *,void *);
  //	virtual bool cmp(void *,void *);
  virtual void cpy(void *&,void *);
  virtual bool rd(ifstream &,void *&);
  virtual bool wr(ofstream &,void *);
public:
  ListOfEntr(void);
  ListOfEntr(ListOfEntr & const);
  ListOfEntr(SledForEntr & const);
  ~ListOfEntr(void);

  ListOfEntr &operator =(ListOfEntr & const);
  ListOfEntr &operator =(SledForEntr & const);

 // bool operator ==(ListOfEntr & const);
 // bool week_equal(ListOfEntr & const);


  bool add(Order *,InfoCopy =copy_when_insert);
  // bool add_quick(Order *,InfoCopy =copy_when_insert);
  bool kick_out(char *);
  Order *lookup(char *);
};



//===========================================================================
class SledForEntr : public GenSled
//===========================================================================
{
public:
  SledForEntr(void) : GenSled() { }
  SledForEntr(ListOfEntr & const l) : GenSled((GenList &)l) {}
  SledForEntr(ListOfEntr * const l) : GenSled((GenList *)l) {}

  ListOfEntr *	get_list_ptr(void);
  void   	copy_entr(SledForEntr*);
  int 		get_entr_key(int);

};



#endif

