/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: domerr.h,v 1.4 1997/06/24 17:28:55 reichel Exp $ *
 ***********************************************************************/


//	domerr.h


#ifndef _DOMFLPERR
#define _DOMFLPERR

#include "errort.h"

extern char domflip_error_prefix[];
extern char *domflip_error_table[];

class domflip_error_t : virtual public error_t
{
public:
  enum error_no { 	ok,
                  	init_ok,
                  	memory_allocation_failed = 5,
                  	name_does_already_exist,
                  	name_does_not_exist,
                  	file_write_error,
                  	file_read_error,
                  	illegal_agg_name_len,
                  	illegal_agg_name_chr,
                 	list_nothing_to_delete,
                 	list_insert_not_permitted,
                  	list_delete_not_permitted,
			set_opt_meth,
                  	file_write_error_in,
                  	file_read_error_in,
                  	clear_error_in,

                  	last_error_no = 30 };

  domflip_error_t(void):error_t() { set_error_table(&domflip_error_table[0],domflip_error_prefix); }
  void clear(void) { error_t::clear(); p_error_no=(error_t::error_no)ok; }
  void set(error_no no,long l=0,char *c ="") { error_t::set((error_t::error_no)no,l,c); }
  error_no get_no(bool flag=false) { return(get_no(flag)); }
};
 
extern domflip_error_t domflip_error;
 
 
#endif

