/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: domflip.cpp,v 1.4 1997/06/24 17:28:56 reichel Exp $ *
 ***********************************************************************/


#include "domflip.h"

DomFlip::DomFlip(void)
{}

DomFlip::~DomFlip(void)
{}

void DomFlip::optimize()
{
  int		i, agg_count;


  agg_count=((SledForAgg *)dom.get_aggs())->get_how_full();
  //cout<<"***IN: Domain::optimize Aggs: "<<agg_count<<endl;

  for(i=1; i<=agg_count; i++)
  {
// cout<<"***Type: "<<((Aggregate *)dom.get_aggs()->operator[](i))->get_type()<<endl;

    if(((Aggregate *)dom.get_aggs()->operator[](i))->get_type()==1) //plan
    {
      //cout<<"***IN: Domain::optimize opt_meth: "<<ometh<<endl;


      switch((int)dom.get_opt_meth())
      {

      case 0:			// TABU REPAIR ALG.
      {
        break_struct 	b;
        para_struct 	pa;
        Tabu 		*t;
        time_t		tm;

	if(debuginfo == 1) cout<<"*** TABU REPAIR ALG.		***"<<endl;		

        dom.evaluate_plan();

        b.what =6; 			// B_KEY;
        b.value = 0.9;
        b.tm = 20;		

        pa.SearchDepth = -1;
        pa.SearchRepeat = -1;
        pa.TriesTillRandom = -1;
        pa.HashSize = -1;
        pa.what = P_OUTPUT | P_DEBUG;

        srand((unsigned) time(&tm)); 

        //cout<<"***IN: Domain::optimize new tabu(...)"<<endl;
        t = new Tabu(&dom,b,pa);

        // cout<<"***IN: Domain::optimize vor tabu_repair_broad()"<<endl;
        t->tabu_repair_broad();
        // t->tabu_repair_deep();
        // dom.get_aggl()dom.get_aggs->get_list_ptr()
 
        dom.set_evaluation(dom.get_aggs());
	exit(0);
      }

      case 1:			//  GENETIC ALG.
      {		
	if(debuginfo == 1) cout<<"*** GENETIC ALG.		***"<<endl;	
	genalg	ga;
	ga.set_string_copy(dom);
	ga.init_start_strings();
	// ga.print_all_acutal_scheds();

	ga.several_steps(5);
	// ga.print_all_acutal_scheds();

	ga.get_string_with_hightest_fitness_copy(dom);

        dom.set_evaluation(dom.get_aggs());
	exit(0);
      }
     }
    }
  }
}


