/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: domlist.h,v 1.4 1997/06/24 17:29:03 reichel Exp $ *
 ***********************************************************************/



#ifndef _DOMLIST
#define _DOMLIST

#include "domerr.h"
#include "common.h"
#include "cflplist.h"

class SledForConstr;
//===========================================================================
class ListOfConstr : public GenList
//===========================================================================
{
protected:
  virtual void del(void *);
  virtual void *key(void *);
  virtual bool look(void *,void *);
  virtual bool cmp(void *,void *);
  virtual void cpy(void *&,void *);
  virtual bool rd(ifstream &,void *&);
  virtual bool wr(ofstream &,void *);
public:
  ListOfConstr(void);
  ListOfConstr(ListOfConstr & const);
  ListOfConstr(SledForConstr & const);
  ~ListOfConstr(void);

  ListOfConstr &operator =(ListOfConstr & const);
  ListOfConstr &operator =(SledForConstr & const);
  bool operator ==(ListOfConstr & const);
  bool week_equal(ListOfConstr & const);

  bool add(char *,InfoCopy =copy_when_insert);
  bool add_quick(char *,InfoCopy =copy_when_insert);
  bool kick_out(char *);
  char *lookup(char *);
};
//===========================================================================
class SledForConstr : public GenSled
//===========================================================================
{
public:
  SledForConstr(void) : GenSled() { }
  SledForConstr(ListOfConstr & const l) : GenSled((GenList &)l) {}
  SledForConstr(ListOfConstr * const l) : GenSled((GenList *)l) {}
};

class SledForInt;
//===========================================================================
class ListOfInt : public GenList
//===========================================================================
{
protected:
  virtual void del(void *);
  virtual void *key(void *);
  virtual bool look(void *,void *);
  virtual bool cmp(void *,void *);
  virtual void cpy(void *&,void *);
  virtual bool rd(ifstream &,void *&);
  virtual bool wr(ofstream &,void *);
public:
  ListOfInt(void);
  ListOfInt(ListOfInt & const);
  ListOfInt(SledForInt & const);
  ~ListOfInt(void);

  ListOfInt &operator =(ListOfInt & const);
  ListOfInt &operator =(SledForInt & const);
  bool operator ==(ListOfInt & const);
  bool week_equal(ListOfInt & const);

  bool add(char *,InfoCopy =copy_when_insert);
  bool add_quick(char *,InfoCopy =copy_when_insert);
  bool kick_out(char *);
  char *lookup(char *);
};
//===========================================================================
class SledForInt : public GenSled
//===========================================================================
{
public:
  SledForInt(void) : GenSled() { }
  SledForInt(ListOfInt & const l) : GenSled((GenList &)l) {}
  SledForInt(ListOfInt * const l) : GenSled((GenList *)l) {}

  int get_key(void);
};
 
#endif
