/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: errort.cpp,v 1.4 1997/06/24 17:29:04 reichel Exp $ *
 ***********************************************************************/


/********************************************************/
/*  modul       ?       errort.cpp                      */
/*------------------------------------------------------*/
/*  project     ?       C O N F L I P + +               */
/********************************************************/
/*  by whom     ?       Gerhilde Egghart                */
/*  with whom   ?       Wolfgang Slany                  */
/*  when        ?       1993/1994                       */
/*  what        ?       modelling of constraints        */
/*  why         ?       Praktikum I + II                */
/*  how         ?       C++                             */
/********************************************************/
/*              ...to be continued...                   */
/*------------------------------------------------------*/
/*  by whom     ?       Georg Fischer                   */
/*  with whom   ?       Wolfgang Slany                  */
/*  when        ?       1994                            */
/*  why         ?       Praktikum I                     */
/*  what done   ?       redesigned and                  */
/*                      making much more sturdy         */
/********************************************************/


#include <stdio.h>
#include <string.h>
#include "errort.h"

extern const char error_txt_prefix[];
extern const char *error_txt[error_t::last_error_no];

error_t::error_t(void)
{
  set_error_table(&p_error_txt_prefix,"");
  strcpy(&(p_error_txt_para[LEN_ERROR_TXT_PARA]),"...");
  clear();
}


void error_t::set_error_table(char **table,char *prefix)
{
  p_error_txt_prefix=prefix;
  p_error_txt=table;
}


void error_t::set(error_no no,long l,char *c)
{
  p_error_no=no;
  p_error_long_para=l;
  strncpy(p_error_txt_para,c,LEN_ERROR_TXT_PARA);
}


error_t::error_no error_t::get_no(bool flag)
{
  error_no help=p_error_no;
  if(flag==true)
    clear();
  return(help);
}


long error_t::get_long_para(void)
{
  return(p_error_long_para);
}


char *error_t::get_txt_para(void)
{
  return(p_error_txt_para);
}


char *error_t::get_txt_eval(void)
{
  char temp[LEN_ERROR_TXT_EVAL];
  strcpy(p_error_txt_eval,p_error_txt_prefix);
  sprintf(temp,p_error_txt[p_error_no],p_error_txt_para,p_error_long_para);
  strcat(p_error_txt_eval,temp);
  return(p_error_txt_eval);
}


void error_t::clear(void)
{
  p_error_no=ok;
  p_error_long_para=0;
  p_error_txt_para[0]='\0';
}
