/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: errort.h,v 1.4 1997/06/24 17:29:05 reichel Exp $ *
 ***********************************************************************/


/********************************************************/
/*  modul       ?       errort.h                        */
/*------------------------------------------------------*/
/*  project     ?       C O N F L I P + +               */
/********************************************************/
/*  by whom     ?       Gerhilde Egghart                */
/*  with whom   ?       Wolfgang Slany                  */
/*  when        ?       1993/1994                       */
/*  what        ?       modelling of constraints        */
/*  why         ?       Praktikum I + II                */
/*  how         ?       C++                             */
/********************************************************/
/*              ...to be continued...                   */
/*------------------------------------------------------*/
/*  by whom     ?       Georg Fischer                   */
/*  with whom   ?       Wolfgang Slany                  */
/*  when        ?       1994                            */
/*  why         ?       Praktikum I                     */
/*  what done   ?       redesigned and                  */
/*                      making much more sturdy         */
/********************************************************/


#ifndef _ERRORT
#define _ERRORT

#include "bool.h"

#define LEN_ERROR_TXT_EVAL 512
#define LEN_ERROR_TXT_PARA 256

class error_t
{
public:
  enum error_no { ok,
                  init_ok,
                  last_error_no };
protected:
  char *p_error_txt_prefix;
  char **p_error_txt;
  error_no p_error_no;
  char p_error_txt_eval[LEN_ERROR_TXT_EVAL];
  char p_error_txt_para[LEN_ERROR_TXT_PARA+4];
  long p_error_long_para;
public:
  error_t(void);
  void set_error_table(char **,char *);
  void set(error_no,long =0,char * ="");
  error_no get_no(bool =false);
  long get_long_para(void);
  char *get_txt_para(void);
  char *get_txt_eval(void);
  void clear(void);
};


#endif
