/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: hash.h,v 1.4 1997/06/24 17:29:12 reichel Exp $ *
 ***********************************************************************/


   /* =========================================================================
                          Hash.h
   ========================================================================= */

#ifndef _HASH
#define _HASH


#define MAX_HASH_SIZE     1000
#define OPT_HASH_SIZE     900
#define HASH_PREC         111111

#include "domlib.h"


class Hash
{
  protected:
    
    float h_tab[MAX_HASH_SIZE];
    int items;
    int quater_it;
    char debug;
    int occupied;

    int h(Domain *);
    int h_2(Domain *);

  public:

    Hash(int,char);
    ~Hash(void);

    void init(void);
    int enter_hash(Domain *);
    float get_hash(int);
    float delete_hash(int);
    int in_hash(Domain *);
    int get_occupied(void);
};

#endif
