/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: replst.cpp,v 1.4 1997/06/24 17:29:16 reichel Exp $ *
 ***********************************************************************/


#include "replst.h"

/*-------------------------------------------------------------------*/
/* ListOfRepairs                                            	     */
/*-------------------------------------------------------------------*/
// ******************************************************************

ListOfRepairs::ListOfRepairs(void) : GenList()
{}
ListOfRepairs::ListOfRepairs(ListOfRepairs & const source) : GenList(source)
{}
ListOfRepairs::ListOfRepairs(SledForRepairs & const source) : GenList(source)
{}
ListOfRepairs::~ListOfRepairs(void)
{
  clear();
}
//===================================================================
void ListOfRepairs::del(void *ptr)
{
  if(ptr!=NULL)
  delete((Repair *)ptr);
}
//===================================================================
void *ListOfRepairs::key(void *info)
{
   return(((Repair *)info)->get_name()); 
}
//=================================================================== 
bool ListOfRepairs::look(void *wanted,void *info)
{
  return((bool)(strcmp((char *)wanted,((Repair *)info)->get_name())==0));
}
/*
//===================================================================
bool ListOfRepairs::cmp(void *ptr1,void *ptr2)
{
  return((bool)(strcmp((char *)ptr1,(char *)ptr2)==0));
}
*/
//=================================================================== 
void ListOfRepairs::cpy(void *&item,void *info)
{  
  item=(Repair *)new(Repair);
  (*(Repair *)item)=(*(Repair *)info);
}

//===================================================================
bool ListOfRepairs::rd(ifstream &infile,void *&item)
{
  Repair temp;

  //cout<<"ListOfRepairs::rd"<<endl;
  //(*(Repair *)item)=temp;
  //cout<<"ListOfRepairs::rd"<<endl;

  
  item=(Repair *)new(Repair);
  if( ((Repair *) item)->read(infile,false))
  {
    return(true);
  }
  else
  {
    delete ((Repair *)item);
    // domflip_error.set(domflip_error_t::file_read_error);
    return(false);
  }
}    
//===================================================================
bool ListOfRepairs::wr(ofstream &outfile,void *item)
{
  return(((Repair *)item)->write(outfile));
} 

//===================================================================

ListOfRepairs &ListOfRepairs::operator =(ListOfRepairs & const source)
{
  clear();
  copy(source);
  //  GenList::operator =(source);
  return(*this);
}


//===================================================================
ListOfRepairs &ListOfRepairs::operator =(SledForRepairs & const source)
{
  clear();
  copy(source);
  // GenList::operator=(source);
  return(*this);
}

//=================================================================== 
/* 
bool ListOfRepairs::operator ==(ListOfRepairs & const par)
{
  return(GenList::operator ==(par));
}
//=================================================================== 
bool ListOfRepairs::week_equal(ListOfRepairs & const par)
{
  return(GenList::week_equal(par));
}
*/ 
//=================================================================== 
bool ListOfRepairs::add(Repair *term,InfoCopy c)
{
  return(GenList::add((void *)term,c));
}
//=================================================================== 
/*
bool ListOfRepairs::add_quick(char *term,InfoCopy c)
{
  return(GenList::add_quick(term,c));
}
//===================================================================  
bool ListOfRepairs::kick_out(char *term)
{
  return(GenList::kick_out(term));
}
*/
//=================================================================== 
Repair *ListOfRepairs::lookup(char *s)
{
  return((Repair *)get_info(GenList::lookup((void *)s)));
}
