/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: repstepd.h,v 1.4 1997/06/24 17:29:18 reichel Exp $ *
 ***********************************************************************/


//===================================================================
bool SledForAgg::call_repair(int f,int pos,ind i)
{
  ind i1,i2;
  int tmp;


  if ( operator()() != NULL)
  {
    tmp= position();

    switch(f)
    {
      case A_MOVE_FWD:					//   <-
	// C (ABCDE) -> (ACBDE)
      {
	if(i.pla < 2) return(false);
	i1.agg=i.agg;		i2.agg=i.agg;
        i1.pla=i.pla; 		i2.pla=i.pla-1;		
	i1.num=i.num;		i2.num=1;
    	if(debuginfo == 1)
	{
          cout<<"  MOVE_FWD:      ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(move(i1,i2));
      }

      case A_MOVE_BWD:					//   ->
	// C (ABCDE) -> (ABDCE) 
      {
	i1.agg=i.agg;		i2.agg=i.agg;
        i1.pla=i.pla; 		i2.pla=i.pla+1;		
	i1.num=i.num;		i2.num=1;
    	if(debuginfo == 1)
	{
          cout<<"  MOVE_BWD:      ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}

        return(move(i1,i2));
      }


      case A_MOVE_GRP_FWD:				// <- 2 items, 2 pl
	// C (ABCDE) -> (CDABE)
      {
	i1.agg=i.agg;		i2.agg=i.agg;
        i1.pla=i.pla; 		i2.pla=i.pla-2;
	i1.num=2;		i2.num=2;
    	if(debuginfo == 1)
	{
          cout<<"  MOVE_GRP_FWD:  ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(move(i1,i2));
      }

      case A_MOVE_GRP_BWD:				// -> 2 items, 2 pl
	// B (ABCDE) -> (ADEBC)
      {
	i1.agg=i.agg;		i2.agg=i.agg;
        i1.pla=i.pla; 		i2.pla=i.pla+2;
	i1.num=2;		i2.num=2;
    	if(debuginfo == 1)
	{
          cout<<"  MOVE_GRP_BWD:  ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(move(i1,i2));
      }


      case A_CHANGE:
	// C (ABCDE) (MNOPR) -> (ABMDE) (CNOPR)
      {
	i1.agg=i.agg;		i2.agg=i1.agg;
        i1.pla=i.pla;		i2.pla=1;
 	i1.num=1;		i2.num=1;
    	if(debuginfo == 1)
	{
          cout<<"  CHANGE:        ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(change(i1,i2));
      }
 
      case A_INSERT:					// from 1 into 2
	// C (ABCDE) (MNOPR) -> (ABDE) (CMNOPR)
      {
        if(i.agg == 2) return(false);
        i1.agg=1;		i2.agg=2;
        i1.pla=i.pla;		i2.pla=1;  	
	i1.num=1;		i2.num=1;
    	if(debuginfo == 1)
	{
          cout<<"  INSERT:        ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(move(i1,i2));
      }

      case A_REMOVE:					// from 2 into 1
	// O (ABCDE) (MNOPR) -> (OABCDE) (MNPR)
      {
        if(i.agg == 1) return(false);
        i1.agg=2; 		i2.agg=1;
        i1.pla=i.pla;		i2.pla=1;
 	i1.num=1;		i2.num=1;
    	if(debuginfo == 1)
	{
          cout<<"  REMOVE:        ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(move(i1,i2));
      }

      case A_MOVE_TO_END:
	// C (ABCDE) -> (ABDEC)
      {
	i1.agg= i.agg; 		i2.agg= i.agg;
        i1.pla=i.pla; 		i2.pla=get_nr_of_entries(); 
	i1.num=1;		i2.num=1;
    	if(debuginfo == 1)
	{
          cout<<"  MOVE_TO_END:   ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(move(i1,i2));
      }

      case A_MOVE_TO_BEG:
	// C (ABCDE) -> (CABDE)
      {
	i1.agg= i.agg;        	i2.agg= i.agg;
        i1.pla=i.pla;		i2.pla=1; 
 	i1.num=1;        	i2.num=1;
    	if(debuginfo == 1)
	{
          cout<<"  MOVE_TO_BEG:   ";
          //cout<<"     Pos1: "<<i1.agg<<" "<<i1.pla<<" "<<i1.num;
          //cout<<"     Pos2: "<<i2.agg<<" "<<i2.pla<<" "<<i2.num<<"    "<<endl;
	}
        return(move(i1,i2));
      }

  
    }
  }
  else 
    cout<<"ERROR: SledForAgg::call_repair() NO AGGREGAT "<<endl;
}


